
const orcl = require('../service/OracleService')

// Chamar assim
// await GeraNovoCodigo('PEDIDOVENDA', 1, null)
async function GeraNovoCodigo(pContador, pQtde, pNrorg){
    let params = {
        'P_CONTADOR' : pContador,
        'P_QTDE' : pQtde,
        'P_NRORG' : pNrorg,
        'P_SEQUENCIAL' : { dir: orcl.oracledb.BIND_OUT, type: orcl.oracledb.STRING, maxSize: 20 }
    }
    
    let query = `
        DECLARE
            P_CONTADOR VARCHAR2(100);
            P_SEQUENCIAL VARCHAR2(20);
            P_QTDE NUMBER;
            P_NRORG NUMBER;
        BEGIN
            P_CONTADOR := :P_CONTADOR;
            P_QTDE := :P_QTDE;
            P_NRORG := :P_NRORG;
            NOVO_CODIGO(
                P_CONTADOR => P_CONTADOR,
                P_SEQUENCIAL => P_SEQUENCIAL,
                P_QTDE => P_QTDE,
                P_NRORG => P_NRORG
            );
            :P_SEQUENCIAL := P_SEQUENCIAL;
        END;
    `
    return await orcl.execProcedure(query, params)
}

module.exports = GeraNovoCodigo