const jwt = require('jsonwebtoken');
const logins = require('../model/loginModel');

class AuthService {
  /**
   * @version 1.1
   * @autor daniel.souza
   * @param {*} email
   * @param {*} password
   * @param {*} cdfilial
   * @returns erro ou token de conexão
   */
  autenticar(email, password, cdfilial) {
    return logins.getLogin({ PASSWORD: password, EMAIL: email }).then((login) => {
      let res = {};
      let tokens = '';
      if (login.rows.length === 0) {
        if (cdfilial !== undefined) {
          tokens = jwt.sign({}, email + cdfilial);
        } else {
          tokens = jwt.sign({}, email);
        }
        res = { error: false, token: tokens };
      } else {
        /** Modificar para Prod - Está permitindo qualquer coisa */
        if (password !== undefined) {
          tokens = jwt.sign({}, email + password);
        } else if (cdfilial !== undefined) {
          tokens = jwt.sign({}, email + cdfilial);
        } else {
          tokens = jwt.sign({}, email);
        }
        res = { error: false, token: tokens };
      }
      return res;
    }).catch(((error) => {
      return { error: true, errorMessage: 'Erro - user/password incorrect', errorCode: error };
    }));
    // return new Promise((accept, reject) => {
    //   if (email == 'francismar.araujo@teknisa.com') {
    //     let secret = !!cdfilial ? email + cdfilial : email;
    //     let token = jwt.sign({}, secret);
    //     accept({ error: false, token: token });
    //   } else {
    //     reject({ error: true, errorMessage: 'user/password incorrect' });
    //   }
    // });
  }
}

module.exports = new AuthService();
