# Odhen Assistant

## Requirements

| Monitoring | Requires |
| --- | --- |
| Conexão | O serviços Master e Sleve precisam estar rodando |
| Sat | A loja precisa ter o Periféricos e Periféricos API |
| Venda | Slave precisa ter comunicação com o Master e acesso ao SQL |
| Delivery | Master precisa ter acesso ao Oracle |


## Operation

| Monitoring | Way |
| --- | --- |
| Portal | O Portal se comunica com o Master por meio de WebSocket |
| Conexão | O Master tenta uma comunicação com o Slave por meio de WebSocket |
| Sat | O Slave faz uma requisição para a API Periféricos e retorna para o Master as informações referente a(os) SAT(s) registrados na tabela CAIXA |
| Venda | O Slave envia para o Master informações das vendas que ainda não foram para o Oracle |
| Delivery | O Master verifica no Oracle os Pedidos que não foram para a Loja, quando o pedido já tem a data superior à 1 Minuto. |
| Sefaz | Select DB seguindo o modelo do Delph |
| Parâmetros | Select na loja para conferir IP de impressora, SAT e outros |



## Project setup - Zeedhi Next



### DOC Zeedhi

See [Reference](https://docs.zeedhi.com/).



### Start All Project

```
Slave:
cd sync\src\slave
.\run_dev.bat
```

```
Master:
cd sync\src\master
.\run_dev.bat
```

```
Portal:
cd src\master\frontend-zeedhi
npm run serve
```
---
#### Data Base
##### Portal:
Importe o Banco de Dados sync\src\master\sqlPoral.sql
Campos:

 - NOME - Nome do Component
 - COMPONENT - Json do Component
 - CONEXAO - Tipo de conexão com o BackEnd
 - STATUS - 0 Inativo, 1 Ativo
 - NAVEGACAO - Se o Item deve aparecer no Grid, Menu e etc
 - ORDEM - Ordem de apresentação dos itens no Grid
 - ITEM - Parte Json para ser adicionado ao COMPONENT

 Na CONEXAO também é possível passar parametros de resposta, como por exemplo o item "interval", ele diz ao BackEnd de quanto em quanto tempo ele deve enviar respostas para o FrontEnd.

    {
		"conexao": [{
			"type": "Socket",
			"route": "login",
			"args": {
				"email": "francismar.araujo@teknisa.com",
				"password": "nineninenine",
				"slave": false
			}
		}, {
			"type": "Socket",
			"route": "sat",
			"args": {
				"interval": 1000 // Fará o monitoramento em 1s
			}
		}]
	}
---
#### Tabelas para as atualizações dos sistemas
##### UPDATER
Tabela registra as filiais e servirá como principal para o UPDATER, a partir desta tabela saberemos o que de sistemas e versões nas lojas.

| CAMPO | DESCRIÇÃO |
| --- | --- |
| IDUPDATER | Gancho para outras tabelas |
| CDFILIAL | Código da filial |
| NOMEFILIAL | Nome da Filial |

---
##### UPDATERSISTEMAS
Tabela responsável por listar os sistemas e suas versões em cada Filial.

| CAMPO | DESCRIÇÃO |
| --- | --- |
| IDUPDATERSISTEMAS | |
| IDUPDATER | Ligação da Tabela UPDATER |
| DEVOPSID | Código do sistema no DevOps |
| APLICACAO | Aplicação |
| SERVICO | Serviço |
| UPSISVERATUAL | Versão ativa |
| SISTEMASSTATUS | Status do sistema |
| | |

- SISTEMASSTATUS ;
  - 0 UPDATER deve instalar o sistema na Loja;
  - 1 Sistema instalado e ativo;
  - 2 Cancelado (desconsidere);
---
##### UPDATERVERSAO
Tabela responsável por armazenar as atualizações e até mesmo a solicitação.

| CAMPO | DESCRIÇÃO |
| --- | --- |
| IDUPDATERVERSAO | Campo gancho |
| IDUPDATERSISTEMAS | Campo de ligação com a Tabela UPDATERSISTEMAS |
| CDOPERADOR | Operador que solicitou a atualização |
| UPVERDATA | Data da atualização |
| UPVERSTATUS | Status da versão.  |
|  |  |

- UPVERSTATUS ;
  - 0 o Master envia a solicitação para o UPDATER, assim que o socket da loja estiver ON;
  - 1 A atualização foi realizada com sucesso;
  - 2 Erro ao tentar atualizar o sistema.
  - 3 Downgrade do sistema
- --


### Fluxo de monitoramento
```mermaid
graph LR
A[Assistant] -- Socket --> B((Server))
B  -- Socket --> C[Client]
C  -- Socket --> B(Server)
B  -- Socket --> A[Assistant]
```
